module Crowdkit
  class Client::Worksets < API
    def get(*args)
      arguments(args, required: [:workset_id])
      do_get("worksets/#{workset_id}")
    end
    alias :find :get

    def list(*args)
      arguments(args, required: [:job_id])
      do_get("jobs/#{job_id}/worksets", arguments.params)
    end
    alias :all :list

    def bonus(*args)
      arguments(args, required: [:workset_id, :amount])
      do_put("worksets/#{workset_id}/bonus", {amount: amount}.merge(arguments.params))
    end

    [:flag, :deflag, :reject, :approve].each do |method|
      define_method(method) do |*args|
        arguments(args, required: [:workset_id, :reason])
        do_put("worksets/#{workset_id}/#{method}", {reason: reason}.merge(arguments.params))
      end
    end
  end
end