class Hash
  # Returns a new hash with all the keys converted to symbols
  #
  def symbolize_keys
    inject({}) do |hash, (key, value)|
      hash[(key.to_sym rescue key) || key] = value
      hash
    end
  end unless method_defined? :symbolize_keys

  # Similar to symbolize_keys but modifies self
  #
  def symbolize_keys!
    hash = symbolize_keys
    hash.each do |key, val|
      hash[key] = case val
        when Hash
          val.symbolize_keys!
        when Array
          val.map do |item|
            item.is_a?(Hash) ? item.symbolize_keys! : item
          end
        else
          val
        end
    end
    return hash
  end unless method_defined? :symbolize_keys!

end
